%Johann Pototschnig, Forttgeschrittene Aplikationssoftware, Ws 2010/2011
%%%%%%%%%%%%%%%%%%%%%%% Variablen
dtmax=0.5;      %Zeitschritte zum rechnen
dtau=dtmax;
darst_t=10000;  % Darstellungszeit
timeparameter=0.25;  % Verfeinerung im beinahe relativistischen
data=struct();
data.anfang=true;
%%%%%%%%%% Physikalische Parameter
m0=0.01;
rs=1;
faktor=0.001;


data.Teilchenbahn=figure;
data.m0=m0;

set(data.Teilchenbahn,'CloseRequestFcn','data.ende=true; data.aus=true;');

%%%%%%%%%%%%%%%%%%%%%%%%%% Startbedingungen

data.ende=false;
% data.ende_put=uicontrol('STYLE','pushbutton', ...
%                    'units','normalized',....
%                    'Position',[0.85,0.01,0.1,0.05],...
%                    'String','Ende',...
%                    'Callback','data.ende=true; data.aus=true;'); 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Kraefte
data.F=[0;0;0];
%Eingabe
data.togbutx=uicontrol('STYLE','pushbutton',...
                   'units','normalized',....
                   'Position',[0.01,0.1,0.1,0.05],...
                   'String','Fx',...
                   'Callback','data=Fcallback(data,1,1,faktor);'); 
data.togbut_x=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.11,0.1,0.1,0.05],...
                   'String','-Fx',...
                   'Callback','data=Fcallback(data,1,2,faktor);'); 
               
data.togbuty=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.01,0.05,0.1,0.05],...
                   'String','Fy',...
                   'Callback','data=Fcallback(data,2,1,faktor);'); 
data.togbut_y=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.11,0.05,0.1,0.05],...
                   'String','-Fy',...
                   'Callback','data=Fcallback(data,2,2,faktor);'); 

data.togbutz=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.01,0.0,0.1,0.05],...
                   'String','Fz',...
                   'Callback','data=Fcallback(data,3,1,faktor);'); 
data.togbut_z=uicontrol('STYLE','pushbutton', ...
                   'units','normalized',....
                   'Position',[0.11,0.0,0.1,0.05],...
                   'String','-Fz',...
                   'Callback','data=Fcallback(data,3,2,faktor);'); 
               
%%%%%%%%%%%%%%%%%%%%% Eingaben
ph1=subplot(3,5,[4,5]);
set(ph1,'visible','off');
data.auswahl_text=text(0,1.2,'Anfangsbedingung waehlen:');

data.auswahl=uicontrol('STYLE','popupmenu', ...
                   'units','normalized',...
                   'Position',[0.7,0.75,0.2,0.2]);
set(data.auswahl,'string',['Perihel ';'Streuung';'Absturz ']);
set(data.auswahl,'callback','data=auswahl_cb(data);');
data.reset=uicontrol('STYLE','pushbutton', ...
                   'units','normalized',....
                   'Position',[0.7,0.84,0.2,0.05],...
                   'String','Reset',...
                   'Callback','data=reset_cb(data);'); 
               
data.metrik_text=text(0,0.5,'Metrik waehlen:');
data.metrik=uicontrol('STYLE','popupmenu', ...
                   'units','normalized',...
                   'Position',[0.7,0.6,0.2,0.2]);
set(data.metrik,'string',['Minkowski    ';'Schwarzschild';'Coulomb      ';'Newton       ']);
set(data.metrik,'value',2);
data=auswahl_cb(data);
data=reset_cb(data);

%%%%%%%%%%%%%%%%%% Darstellung 

subplot(3,5,[1,2,3,6,7,8,11])%,12,13
pposition=plot3(data.x(1),data.x(2),data.x(3),'b+');
hold on
%_____________________Urprungskugel
[KX,KY,KZ]=sphere(10);
KX=rs*KX;
KY=rs*KY;
KZ=rs*KZ;
Ukugel=mesh(KX,KY,KZ);
%_______________Teilchenbahn
phistory=plot3(data.x(1),data.x(2),data.x(3),'ro');
data.pold=plot3(data.x(1),data.x(2),data.x(3),'go');
set(phistory,'markersize',3);
set(data.pold,'markersize',1);

grid on
hold off

%%%%%%%%%%%%%%%%%%%%%%% Energie
subplot(3,5,[9,10])
plotEnergie=plot(0,0,'b');
hold on
data.plotEnergieold=plot(0,0,'g');
data.EnergieTitel=title('kinetische Energie');
hold off
grid on

%%%%%%%%%%%%%%%%%% Geschwindigkeit
subplot(3,5,[14,15])
plot_veigen=plot(0,0,'b');
set(plot_veigen,'displayname','Eigenzeit');
hold on
plot_vbeobachter=plot(0,0,'r');
data.plot_vbeobachterold=plot(0,0,'g');
set(plot_vbeobachter,'displayname','Beobachter');
set(data.plot_vbeobachterold,'displayname','Beobachter, alt');
legend('show');
legend('location',[0.65,0.03,0.1,0.04]);
data.GeschwindigkeitTitel=title('  Geschwindigkeiten ');
grid on
hold off


%%%%%%%%%%%%%%% Schleife
while(true)
while(~data.aus)
    %Berechnung der Beschleunigung
    metrik=get(data.metrik,'value');
    switch metrik
        case 1
            ar = Ku_Metrik( data.r, data.vr,rs,data.vt);
        case 2
            ar = SM_Metrik( data.r, data.vr,rs,data.vt);
        case 3
            ar = C_Metrik( data.r, data.vr,rs,data.vt);
        case 4
            ar = N_Metrik( data.r, data.vr,rs,data.vt);
    end
    data.at=ar(1);
    data.ar=ar(2:end).';

    data.ax=ar2ax(data.r,data.vr,data.ar);
    
    %Kraft hinzufuegen
    data.ax=data.ax+data.F/m0;
    data.F=[0;0;0];
    
%     ev=data.vx/sqrt(sum(data.vx.^2));
%     
%     Fv=(data.ax.'*ev)*ev;
%     Fx=(data.ax-Fv);
%     ahv=Fv/(data.gam^3*sum(data.vx.^2)+data.gam);
%     ahx=Fx/(data.gam);
%     data.ax=ahv+ahx;
    
    %Berechnung des Zeitschritts
    data.vx=data.vx+data.ax*dtau;
    if((dtau<dtmax) && (1-sum(data.vx.^2)>0))
        dtau=dtau*1/timeparameter;
    else
        while ((1-sum(data.vx.^2))<0)
            data.vx=data.vx-data.ax*dtau;
            dtau=dtau*timeparameter;
            data.vx=data.vx+data.ax*dtau;
        end
    end 
    %Berechnung des relativistischen Faktors
    data.gam=sqrt(1/abs(1-sum(data.vx.^2)));
    if(data.gam==inf)
                h=errordlg('stehengeblieben');
                uiwait(h);
                data.aus=true;
    end
    data.x=data.x+data.vx*dtau;
    
    data.r=x2r(data.x);
    data.vr=vx2vr(data.x,data.vx);
    
    data.vt=data.vt+data.at*dtau;
    dt=data.vt*dtau*data.gam;
    data.t=data.t+dt;
    
    %Vektorespeicherung
    data.xvec=[data.xvec,data.x];
    data.vxvec=[data.vxvec,data.vx];
    data.axvec=[data.axvec,data.ax];
    
    data.rvec=[data.rvec,data.r];
    data.vrvec=[data.vrvec,data.vr];
    data.arvec=[data.arvec,data.ar];
    
    data.cvec=[data.cvec,data.count];
    data.tvec=[data.tvec,data.t];
    %_____________Darstellung
    set(pposition,'xdata',data.x(1),'ydata',data.x(2),'zdata',data.x(3));
    set(phistory,'xdata',data.xvec(1,:),'ydata',data.xvec(2,:),'zdata',data.xvec(3,:));
    
    %%%%%%%%%%%  Analyse
    E=m0*data.gam;
    data.Evec=[data.Evec,E];
    data.countvec=[data.countvec,data.count];
    
    v_2=sum(data.vx.^2);
    data.veigen=[data.veigen,v_2];
    v_22=sum(data.vx.^2/data.gam);
    data.vbeobachter=[data.vbeobachter,v_22];
    
    %_________________Darstellung
    set(plotEnergie,'xdata',data.tvec,'ydata',data.Evec);
    set(plot_veigen,'xdata',data.tvec,'ydata',data.veigen);
    set(plot_vbeobachter,'xdata',data.tvec,'ydata',data.vbeobachter);

    %_______________________________Zeichnen und Pause
    if(~isnan(dt) && dt<10000)
        pause(dt/darst_t);
    end
    drawnow
    
    % Ende
    data.count=data.count+1;
    if(data.count>10000)
        break;
    end
    
%     if(r(1)<rs)
%         h=errordlg('verschluckt');
%         break;
%     end  

end 
    
    if(data.ende) %Programm beendeen
        delete(data.Teilchenbahn);
        break;
    end
    


    data=reset_cb(data);
end
