%Johann Pototschnig, Forttgeschrittene Aplikationssoftware, Ws 2010/2011
%%%%%%%%%%%%%%%%%%%%%%% Variablen
dtmax=0.5;
dtau=dtmax;
darst_t=10000;
timeparameter=0.25;
data=struct();
%%%%%%%%%% Physikalische Parameter
m0=0.01;
rs=1;
faktor=0.001;


data.Teilchenbahn=figure;
data.m0=m0;
%%%%%%%%%%%%%%%%%%%%%%%%%% Startbedingungen
data.auswahl=uicontrol('STYLE','popupmenu', ...
                   'units','normalized',...
                   'Position',[0.01,0.8,0.2,0.2]);
set(data.auswahl,'string',['Perihel ';'Streuung';'Absturz ']);
set(data.auswahl,'callback','data=auswahl_cb(data);');

data.metrik=uicontrol('STYLE','popupmenu', ...
                   'units','normalized',...
                   'Position',[0.25,0.8,0.2,0.2]);
set(data.metrik,'string',['Minkowski    ';'Schwarzschild';'Coulomb      ';'Newton       ']);
set(data.metrik,'value',2);

data.reset=uicontrol('STYLE','pushbutton', ...
                   'units','normalized',....
                   'Position',[0.01,0.88,0.2,0.05],...
                   'String','Reset',...
                   'Callback','data=reset_cb(data);'); 
               
data=auswahl_cb(data);
data=reset_cb(data);

data.ende=false;
data.ende_put=uicontrol('STYLE','pushbutton', ...
                   'units','normalized',....
                   'Position',[0.8,0.01,0.2,0.05],...
                   'String','Ende',...
                   'Callback','data.ende=true; data.aus=true;'); 


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%% Kr?fte
data.F=[0;0;0];
%Eingabe
data.togbutx=uicontrol('STYLE','pushbutton',...
                   'units','normalized',....
                   'Position',[0.01,0.1,0.1,0.05],...
                   'String','Fx',...
                   'Callback','data=Fcallback(data,1,1,faktor);'); 
data.togbut_x=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.11,0.1,0.1,0.05],...
                   'String','-Fx',...
                   'Callback','data=Fcallback(data,1,2,faktor);'); 
               
data.togbuty=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.01,0.05,0.1,0.05],...
                   'String','Fy',...
                   'Callback','data=Fcallback(data,2,1,faktor);'); 
data.togbut_y=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.11,0.05,0.1,0.05],...
                   'String','-Fy',...
                   'Callback','data=Fcallback(data,2,2,faktor);'); 

data.togbutz=uicontrol('STYLE','pushbutton', ....
                   'units','normalized',....
                   'Position',[0.01,0.0,0.1,0.05],...
                   'String','Fz',...
                   'Callback','data=Fcallback(data,3,1,faktor);'); 
data.togbut_z=uicontrol('STYLE','pushbutton', ...
                   'units','normalized',....
                   'Position',[0.11,0.0,0.1,0.05],...
                   'String','-Fz',...
                   'Callback','data=Fcallback(data,3,2,faktor);'); 
               
%%%%%%%%%%%%%%%%%%%%% Darstellung
pposition=plot3(data.x(1),data.x(2),data.x(3),'b+');
hold on
%_____________________Urprungskugel
[KX,KY,KZ]=sphere(10);
KX=rs*KX;
KY=rs*KY;
KZ=rs*KZ;
Ukugel=mesh(KX,KY,KZ);
%_______________Teilchenbahn
phistory=plot3(data.x(1),data.x(2),data.x(3),'ro');
set(phistory,'markersize',3);
grid on
hold off


%%%%%%%%%%%%%%% Schleife
while(true)
while(~data.aus)
    %Berechnung der Beschleunigung
    metrik=get(data.metrik,'value');
    switch metrik
        case 1
            ar = Ku_Metrik( data.r, data.vr,rs,data.vt);
        case 2
            ar = SM_Metrik( data.r, data.vr,rs,data.vt);
        case 3
            ar = C_Metrik( data.r, data.vr,rs,data.vt);
        case 4
            ar = N_Metrik( data.r, data.vr,rs,data.vt);
    end
    data.at=ar(1);
    data.ar=ar(2:end).';

    data.ax=ar2ax(data.r,data.vr,data.ar);
    
    %Kraft hinzuf?gen
    data.ax=data.ax+data.F/m0;
    data.F=[0;0;0];
    
%     ev=data.vx/sqrt(sum(data.vx.^2));
%     
%     Fv=(data.ax.'*ev)*ev;
%     Fx=(data.ax-Fv);
%     ahv=Fv/(data.gam^3*sum(data.vx.^2)+data.gam);
%     ahx=Fx/(data.gam);
%     data.ax=ahv+ahx;
    
    %Berechnung des Zeitschritts
    data.vx=data.vx+data.ax*dtau;
    if((dtau<dtmax) && (1-sum(data.vx.^2)>0))
        dtau=dtau*1/timeparameter;
    else
        while ((1-sum(data.vx.^2))<0)
            data.vx=data.vx-data.ax*dtau;
            dtau=dtau*timeparameter;
            data.vx=data.vx+data.ax*dtau;
        end
    end 
    %Berechnung des relativistischen Faktors
    data.gam=sqrt(1/abs(1-sum(data.vx.^2)));
    if(data.gam==inf)
                h=errordlg('stehengeblieben');
                uiwait(h);
                data.aus=true;
    end
    data.x=data.x+data.vx*dtau;
    
    data.r=x2r(data.x);
    data.vr=vx2vr(data.x,data.vx);
    
    data.vt=data.vt+data.at*dtau;
    dt=data.vt*dtau*data.gam;
    data.t=data.t+dt;
    
    %Vektorespeicherung
    data.xvec=[data.xvec,data.x];
    data.vxvec=[data.vxvec,data.vx];
    data.axvec=[data.axvec,data.ax];
    
    data.rvec=[data.rvec,data.r];
    data.vrvec=[data.vrvec,data.vr];
    data.arvec=[data.arvec,data.ar];
    
    data.cvec=[data.cvec,data.count];
    data.tvec=[data.tvec,data.t];
    %_____________Darstellung
    set(pposition,'xdata',data.x(1),'ydata',data.x(2),'zdata',data.x(3));
    set(phistory,'xdata',data.xvec(1,:),'ydata',data.xvec(2,:),'zdata',data.xvec(3,:));
    

    %_______________________________Zeichnen und Pause
    if(~isnan(dt) && dt<10000)
        pause(dt/darst_t);
    end
    drawnow
    
    % Ende
    data.count=data.count+1;
    if(data.count>10000)
        break;
    end
    
%     if(r(1)<rs)
%         h=errordlg('verschluckt');
%         break;
%     end  

end 
    
    if(data.ende) %Programm beendeen
        close(data.Teilchenbahn);
        break;
    end
    
    data=reset_cb(data);
end
